package summarymeasures;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

/**
 * InputButton.java
 * Created by Stijn Strickx on Mar. 2 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */
public class InputButton extends JButton implements ActionListener{
    
    private InputModel inModel;
    private OutputModel outModel;
    private String text;
    
    public InputButton(InputModel inModel, OutputModel outModel, String text){
        super(text);
        this.text = text;
        this.inModel = inModel;
        this.outModel = outModel;
        addActionListener(this);
    }
    public void actionPerformed(ActionEvent e) {
        if(text.equals("ENT")){
            outModel.addOutput(inModel.getInput());
            inModel.resetInput();            
        }
        else if(text.equals("DEL")){
            inModel.resetInput();
            outModel.resetOutput();            
        }
        else{
            inModel.addInput(text);            
        }
    }
}
