package summarymeasures;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

/**
 * Model.java
 * Created by Stijn Strickx on Mar. 2 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */
public class Model {
    
    private EventListenerList listenerList;
    private final ChangeEvent changeEvent;
    
    public Model(){        
        listenerList = new EventListenerList();
        changeEvent = new ChangeEvent(this);
    }
    
    public void addChangeListener(ChangeListener l){
        listenerList.add(ChangeListener.class, l);        
    }
    public void removeChangeListener(ChangeListener l){
        listenerList.remove(ChangeListener.class, l);        
    }

    protected void fireStateChanged() {
        Object[] listeners = listenerList.getListenerList();
        for(int i = listeners.length-2; i>=0; i-=2){
            if(listeners[i] == ChangeListener.class)
                ((ChangeListener)listeners[i+1]).stateChanged(changeEvent);
        }
    }
}
