package summarymeasures;

import java.util.ArrayList;

/**
 * OutputModel.java
 * Created by Stijn Strickx on Mar. 2 2008
 * Copyright 2008 Stijn Strickx, All rights reserved
 */
public class OutputModel extends Model{
    
    private ArrayList<Integer> outputs;
    private String output;
    private String noval;
    private String activeRadio;
    
    public OutputModel(){
        outputs = new ArrayList<Integer>();
        noval = "No input available.";
        output = noval;
        activeRadio = "amount";
    }    
    public void addOutput(String input){        
        outputs.add(Integer.parseInt(input));
        setOutput();
        fireStateChanged();
    }    
    public void setNum(){
        if(outputs.size()>0)
            output = "" + outputs.size();
        else
            output = noval;
        fireStateChanged();
    }    
    public void setSum(){
        if(outputs.size()>0)
            output = "" + getSum();
        else 
            output = noval;
        fireStateChanged();
    }
    public void setAvg(){
        if(outputs.size()>0)
            output = "" + getAvg();
        else
            output = noval;
        fireStateChanged();
    }    
    public void setVar(){
        double sum = 0;
        double avg = getAvg();
        for(int x=0; x<outputs.size(); x++)
            sum += Math.pow((double)outputs.get(x) - avg, 2);
        if(outputs.size()>0)
            output = "" + sum/(double)outputs.size();
        else
            output = noval;
        fireStateChanged();
    }
    
    public void setOutput() {
        if(activeRadio.equals("amount")){
            setNum();            
        }
        else if(activeRadio.equals("sum")){
            setSum();            
        }
        else if(activeRadio.equals("avg")){
            setAvg();            
        }
        else{
            setVar();
        }
    }
    public void setActiveRadio(String active){
        activeRadio = active;
        setOutput();
    }
    public int getSum(){
        int sum = 0;
        for(int num : outputs)
            sum+=num;
        return sum;
    }
    public double getAvg(){
        return (double)getSum()/(double)outputs.size();        
    }
    public String getOutput(){
        return output;
    }    
    public void resetOutput(){
        outputs.clear();
        output = noval;
        fireStateChanged();
    }
}
